package com.huimv.receive.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author author
 * @since 2024-03-06
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("base_washout_point")
public class BaseWashoutPoint implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 地点id
     */
    private Integer locationId;

    /**
     * 地点名称
     */
    @TableField(exist = false)
    private String locationName;

    /**
     * 所属牧场
     */
    private String farmIds;

    /**
     * 流程列表
     */
    private String flowList;

    /**
     * 前面地点名称
     */
    private String headLocationName;

    /**
     * 后面地点名称
     */
    private String tailLocationName;

    /**
     * 洗消点等级
     */
    private Integer pointLevel;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * pcr有效时长(分钟)
     */
    private Integer pcrTime;

    /**
     * 来访类型
     */
    private Integer visitingType;


}
